<?php
// print_r(explode('|', $str, 2));
class ProductEntry {
	private $shortName; // the name that shall appear on the button of the waiter
	private $priceA; // the price of the product (default)
	private $priceB; // price level B
	private $priceC; // price level C
	private $longName; // the name that shall appear on the receipt
	
	// Constructor - gehts the line as it is in the Speisekarte
	function __construct($aTextLine) {
		// is there multiple price levels?
		$numberOfPrices = 1;
		$priceparts = explode('#', $aTextLine, 2);
		$price_level_B = "0.00";
		$price_level_C = "0.00";
		if (count($priceparts) == 2) {
			// there is a # in the line --> probably two prices
			$otherPrices = $priceparts[1];
			// are there level 2&3 or only 2?
			$otherPriceParts = explode(';', $otherPrices, 2);
			$price_level_B = trim(floatval($otherPriceParts[0]));
			if (count($otherPriceParts) == 1) {
				$numberOfPrices = 2;
			} else if (count($otherPriceParts) == 2) {
				$price_level_C = trim(floatval($otherPriceParts[1]));
				$numberOfPrices = 3;
			} else {
				// undefined
				$numberOfPrices = 1; // fall back to default
			}
		}
			
		$parts = explode(';', $priceparts[0], 3);
		$this->shortName = trim($parts[0]);
		$this->priceA = trim(floatval($parts[1]));
		// default: all the same price
		$this->priceB = $this->priceA;
		$this->priceC = $this->priceA;
		if ($numberOfPrices == 2) {
			$this->priceB = $price_level_B; // A = C, only B is different
		} else if ($numberOfPrices == 3) {
			$this->priceB = $price_level_B;
			$this->priceC = $price_level_C;
		}
		
		if (count($parts) < 3) {
			// in this case the button name is the same as the name on the bill
			$this->longName = $this->shortName;
		} else {
			$this->longName = trim($parts[2]);
		}
	}
	
	function getShortName() {
		return $this->shortName;
	}
	function getPriceA() {
		return $this->priceA;
	}
	function getPriceB() {
		return $this->priceB;
	}
	function getPriceC() {
		return $this->priceC;
	}
	function getLongName() {
		return $this->longName;
	}
	
	function toString() {
		return "S:" . $this->shortName . " PA:" . $this->priceA . " PB:" . $this->priceB . " PC:" . $this->priceC  . " R:" . $this->longName;
	}
}